require 'soar/registry/identity/provider/staff/email'
require 'soar/registry/identity/provider/staff/uuid'
require 'soar/registry/identity/provider/customer/client_number'
require 'soar/registry/identity/provider/customer/email'
require 'soar/registry/identity/provider/customer/uuid'
require 'soar/registry/identity/provider/stub/uuid'
require 'soar/registry/identity/directory'

module Soar
  module Registry
    module Identity
      class Model

        attr_reader :provider

        def initialize(provider)
          @provider = provider
        end

        ##
        # @param [String] identifier 
        # @return [Array<String>] list of roles
        ##
        def get_roles(identifier)
          @provider.get_roles(identifier)
        end

        ##
        # @param [String] identifier
        # @param [String] role
        # @return [Hash{String => String, Hash, Number}] 
        #   if a role is specified the returned hash is keyed by role
        #   else it's keyed by attribute name
        # @raise [SoarIdm::IdentityError]
        ##
        def get_attributes(identifier, role = nil)
          @provider.get_attributes(identifier, role)
        end

        ##
        # @param [String] identifier
        # @return [Array<String>] 
        #   array of identity identifiers
        ##
        def get_identifiers(identifier)
          @provider.get_identifiers(identifier)
        end
      end
    end
  end
end
